/**
 * Created by John on 11/17/2016.
 *
 * Shared topology of the RabbitMQ exchanges and queues
 */
module.exports = function(rabbit, subscribeTo, config) {

    return rabbit.configure({

        // arguments used to establish a connection to a broker
        connection: config.rabbitConfig,

        // define the exchanges
        exchanges: [{
            name: "topic-fresenius-x",
            type: "topic",
            autoDelete: true
        }],

        // setup the queues, only subscribing to the one this service
        // will consume messages from
        queues: [{
            name: "topic-fresenius-asn-q",
            autoDelete: true,
            subscribe: true
        }, {
            name: "topic-fresenius-po-q",
            autoDelete: true,
            subscribe: subscribeTo === 'po'
        }],

        // binds exchanges and queues to one another
        bindings: [{
            exchange: "topic-fresenius-x",
            target: "topic-fresenius-asn-q",
            keys: ["asn"]
        }, {
            exchange: "topic-fresenius-x",
            target: "topic-fresenius-po-q",
            keys: ["po"]
        }]
    }).then(null, function(err) {
        console.error('Could not connect or configure:', err);
    });
};