/**
 * Created by John on 4/4/2017.
 */
var cluster = require('cluster');
var clusterManager = require('cluster-manager');
var numCPUs = require('os').cpus().length;
var env = process.env.NODE_ENV || "dev";
var config      = require("./components/config/server." + env + ".js");

if (cluster.isMaster) {

    require("./components/config/genSecret")();

    var forks = (env == "dev") ? 2 : numCPUs;

    cluster.on('online', function(worker) {
        console.log('Worker ' + worker.process.pid + ' is online');
    });

    clusterManager({
        exec: "./child.js",
        workers: forks,
        notify: null
    });

    //only one job scheduler should instantiate, so keep it in master
    require("./components/jobs/jobSchedule")(config);

}

process.on('uncaughtException', function (err) {
    var msg = (new Date).toUTCString() + ' uncaughtException:';
    console.error(msg, err.message);
    console.error(err.stack);
    process.exit(1);
});